#install.packages("plotrix")
require(plotrix)



n_col = c(16, 32, 64, 128, 256, 512, 1024)
mle_kl = c(0.61969688, 0.17400299, 0.06852356, 0.03823606, 0.02191736, 0.01531169, 0.01252997)
l2_kl = c(0.84415508, 0.17403725, 0.06852356, 0.03823606, 0.02191736, 0.01531169, 0.01252997)
l2_dev = c(0.59768934, 0.00472937, 0.00000000, 0.00000000, 0.00000000, 0.00000000, 0.00000000)
ice_kl = c(0.30185158, 0.13678543, 0.05806635, 0.03527745, 0.02119806, 0.01512611, 0.01245325)
ice_dev = c(0.52504304, 0.07489203, 0.01848535, 0.00594375, 0.00205059, 0.00073260, 0.00034131)

n_samples = 500

# Plot the 2 standard deviation error bars.
ice_dev = 2 * ice_dev / sqrt(n_samples)
l2_dev = 2 * l2_dev / sqrt(n_samples)

l2_kl = l2_kl / mle_kl
l2_dev = l2_dev / mle_kl
ice_kl = ice_kl / mle_kl
ice_dev = ice_dev / mle_kl
mle_kl = mle_kl / mle_kl

kl.df <- data.frame(cbind(n_col, mle_kl, l2_kl, ice_kl, l2_dev, ice_dev))


setEPS()
postscript("friedman-kl.eps")



plotCI(kl.df$n_col, kl.df$ice_kl, col="green", las=1, xlab="N", ylab="KL Divergence", log="x", ylim=c(0.4, 1.5), uiw=kl.df$ice_dev, pch="o")
lines(kl.df$n_col, kl.df$mle_kl, col="blue", pch="*")
par(new = TRUE)
plotCI(kl.df$n_col, kl.df$l2_kl, col="red", las=1, xlab="", ylab="", log="x", uiw=kl.df$l2_dev, pch="+", axes=FALSE, add=TRUE)
#plotCI(kl.df$n_col, kl.df$l2_kl, col="red", las=1, xlab="", ylab="", log="xy", uiw=2*kl.df$l2_dev, liw=pmin(l2_kl*0.99, 2*l2_dev), pch="+", axes=FALSE, add=TRUE)



legend(500,1.4,legend=c("mle","ICE","L2"), col=c("blue","green","red"),
                                   pch=c("*","o","+"),lty=c(1,2,3), ncol=1)
                                   
                                   
dev.off()

